package com.pastamadre.mypm;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Vector;

import android.util.Log;

public class AlmacenPuntuacionesHosting implements AlmacenPuntuaciones {

	public Vector<String> listaPuntuaciones(int cantidad) {
		Vector<String> result = new Vector<String>();
		try {
			URL url = new URL("http://dog-h.com/MyPM/lista.php" + "?max=20");
			HttpURLConnection conexion = (HttpURLConnection) url
					.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				while (!linea.equals("")) {
					result.add(linea);
					linea = reader.readLine();
				}
				reader.close();
				return result;
			} else {
				Log.e("MyPM", conexion.getResponseMessage());
				return result;
			}
		} catch (Exception e) {
			Log.e("MyPM", e.getMessage(), e);
			return result;
		}
	}

	public void guardarPuntuacion(String ciudad, String nombre, int puntos,
			String password, long ms) {
		try {
			URL url = new URL("http://dog-h.com/MyPM/nueva.php" + "?ciudad="
					+ URLEncoder.encode(ciudad, "UTF-8") + "&nombre="
					+ URLEncoder.encode(nombre, "UTF-8") + "&puntos=" + puntos
					+ "&password=" + URLEncoder.encode(password, "UTF-8")
					+ "&ms=" + ms);
			HttpURLConnection conexion = (HttpURLConnection) url
					.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				if (!linea.equals("OK")) {
					Log.e("MyPM", "Error en servicio Web");
				}
			} else {
				Log.e("MyPM", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e) {
			Log.e("MyPM", e.getMessage(), e);
		}
	}

	public void actualizarPuntuacion(String ciudad, String nombre, int puntos,
			String password, long ms) {
		try {
			URL url = new URL("http://dog-h.com/MyPM/actualiza.php"
					+ "?ciudad=" + URLEncoder.encode(ciudad, "UTF-8")
					+ "&nombre=" + URLEncoder.encode(nombre, "UTF-8")
					+ "&puntos=" + puntos + "&password="
					+ URLEncoder.encode(password, "UTF-8") + "&ms=" + ms);
			HttpURLConnection conexion = (HttpURLConnection) url
					.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				if (!linea.equals("OK")) {
					Log.e("MyPM", "Error en servicio Web");
				}
			} else {
				Log.e("MyPM", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e) {
			Log.e("MyPM", e.getMessage(), e);
		}
	}

}
