package com.pastamadre.mypm;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Vector;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.InputStreamEntity;
import org.apache.http.impl.client.DefaultHttpClient;

import android.util.Log;

public class AlmacenRecetasHosting implements AlmacenRecetas {

	public Vector<String> listaRecetas(int cantidad, String tipo, String idioma) {
		Vector<String> result = new Vector<String>();

		try {
			URL url = new URL("http://dog-h.com/MyPM/listar.php" + "?max=20"
					+ "&tipo=" + URLEncoder.encode(tipo, "UTF-8") + "&idioma="
					+ URLEncoder.encode(idioma, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url
					.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				while (!linea.equals("")) {
					result.add(linea);
					linea = reader.readLine();
				}
				reader.close();
				return result;
			} else {
				Log.e("MyPM", conexion.getResponseMessage());
				return result;
			}
		} catch (Exception e) {
			Log.e("MyPM", e.getMessage(), e);
			return result;
		}
	}

	public void guardarRecetas(String tipo, String nombrereceta,
			String ingredientes, String primeraexp, int tiempoprimera,
			String segundaexp, int tiemposegunda, String terceraexp,
			int tiempohorno, int temperatura, String idioma, String nombre) {

		try {
			URL url2 = new URL("http://dog-h.com/MyPM/nuevar.php" + "?tipo="
					+ URLEncoder.encode(tipo, "UTF-8") + "&nombrereceta="
					+ URLEncoder.encode(nombrereceta, "UTF-8")
					+ "&ingredientes="
					+ URLEncoder.encode(ingredientes, "UTF-8") + "&primeraexp="
					+ URLEncoder.encode(primeraexp, "UTF-8")
					+ "&tiempoprimera=" + tiempoprimera + "&segundaexp="
					+ URLEncoder.encode(segundaexp, "UTF-8")
					+ "&tiemposegunda=" + tiemposegunda + "&terceraexp="
					+ URLEncoder.encode(terceraexp, "UTF-8") + "&tiempohorno="
					+ tiempohorno + "&temperatura=" + temperatura + "&idioma="
					+ URLEncoder.encode(idioma, "UTF-8") + "&nombre="
					+ URLEncoder.encode(nombre, "UTF-8"));

			HttpURLConnection conexion = (HttpURLConnection) url2
					.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				if (!linea.equals("OK")) {
					Log.e("MyPM", "Tienes un Error en el servicio Web");
				}
			} else {
				Log.e("MyPM", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e) {
			Log.e("MyPM", e.getMessage(), e);
		}

	}
}
