package com.pastamadre.mypm;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.StrictMode;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class IntroducirReceta extends Activity {
	private TextView titulo;
	private static String idioma;
	private static String tipo;
	String nombre;
	private EditText nombrerecetae;
	private EditText ingredientese;
	private EditText primeraexpe;
	private EditText segundaexpe;
	private EditText terceraexpe;
	private EditText tiempoprimerae;
	private EditText tiemposegundae;
	private EditText temperaturae;
	private EditText tiempohornoe;
	private Uri uriFoto;
	private static String nombrereceta;
	private static String ingredientes;
	private static String primeraexp;
	private static String segundaexp;
	private static String terceraexp;
	private static int tiempoprimera;
	private static int tiemposegunda;
	private static int temperatura;
	private static int tiempohorno;
	public static AlmacenRecetas almacen2 = new AlmacenRecetasHosting();
	private ImageView imageView;
	private String foto;
	private static File fileFoto;
	final static int RESULTADO_EDITAR = 1;
	final static int RESULTADO_GALERIA = 2;
	final static int RESULTADO_FOTO = 3;
	int puntos;

	private TextView messageText;
	private Button uploadButton, btnselectpic;
	private ImageView imageview;
	private int serverResponseCode = 0;
	private ProgressDialog dialog = null;
	private String upLoadServerUri = null;
	private String imagepath = null;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()
				.permitNetwork().build());

		setContentView(R.layout.meter_recetas);
		actualizarVistas();

		upLoadServerUri = "http://dog-h.com/MyPM/guardarFoto.php";

		idioma = getString(R.string.clave);
		Bundle extras = getIntent().getExtras();
		nombre = extras.getString("nombre");
		tipo = extras.getString("tipo");
		puntos = extras.getInt("puntos");

		nombrerecetae = (EditText) findViewById(R.id.nombre_receta_dato);
		ingredientese = (EditText) findViewById(R.id.ingredientes_dato);
		primeraexpe = (EditText) findViewById(R.id.primera_explicacion_dato);
		tiempoprimerae = (EditText) findViewById(R.id.primer_tiempo_fermentacion_dato);
		segundaexpe = (EditText) findViewById(R.id.segunda_explicacion_dato);
		tiemposegundae = (EditText) findViewById(R.id.segundo_tiempo_fermentacion_dato);
		terceraexpe = (EditText) findViewById(R.id.tercera_explicacion_dato);
		temperaturae = (EditText) findViewById(R.id.temperatura_dato);
		tiempohornoe = (EditText) findViewById(R.id.primer_tiempo_horno_dato);

		Button enviarReceta = (Button) findViewById(R.id.boton_enviar_receta);
		enviarReceta.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				puntos = puntos + 80;
				nombrereceta = nombrerecetae.getText().toString();
				ingredientes = ingredientese.getText().toString();
				primeraexp = primeraexpe.getText().toString();
				tiempoprimera = Integer.valueOf((tiempoprimerae.getText())
						.toString());

				segundaexp = segundaexpe.getText().toString();
				tiemposegunda = Integer.valueOf((tiemposegundae.getText())
						.toString());

				terceraexp = terceraexpe.getText().toString();
				temperatura = Integer.valueOf((temperaturae.getText())
						.toString());

				tiempohorno = Integer.valueOf((tiempohornoe.getText())
						.toString());

				Toast.makeText(
						IntroducirReceta.this,
						"Muchas Gracias, receta introducida correctamente en la base de datos.",
						Toast.LENGTH_SHORT).show();

				MiThread thread = new MiThread();
				thread.start();

				finish();
			}

		});

	}

	class MiThread extends Thread {
		@Override
		public void run() {
			uploadFile(imagepath);
			almacen2.guardarRecetas(tipo, nombrereceta, ingredientes,
					primeraexp, tiempoprimera, segundaexp, tiemposegunda,
					terceraexp, tiempohorno, temperatura, idioma, nombre);

		}
	}

	public void galeria(View view) {
		Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
		intent.addCategory(Intent.CATEGORY_OPENABLE);
		intent.setType("image/*");
		startActivityForResult(intent, RESULTADO_GALERIA);
	}

	protected void ponerFoto(ImageView imageView, String uri) {
		if (uri != null) {
			imageView.setImageBitmap(reduceBitmap(this, uri, 1024, 1024));
		} else {
			imageView.setImageBitmap(null);
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == RESULTADO_EDITAR) {
			actualizarVistas();
			findViewById(R.id.scrollView_meter_recetas).invalidate();
		} else if (requestCode == RESULTADO_GALERIA
				&& resultCode == Activity.RESULT_OK) {
			foto = data.getDataString();
			ponerFoto(imageView, foto);
			Uri selectedImageUri = data.getData();
			imagepath = getPath(selectedImageUri);

		}
	}

	public String getPath(Uri uri) {
		String[] projection = { MediaStore.Images.Media.DATA };
		Cursor cursor = managedQuery(uri, projection, null, null, null);
		int column_index = cursor
				.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
		cursor.moveToFirst();
		return cursor.getString(column_index);
	}

	protected void actualizarVistas() {
		imageView = (ImageView) findViewById(R.id.foto);

	}

	public void eliminarFoto(View view) {
		foto = null;
		ponerFoto(imageView, null);
	}

	public static Bitmap reduceBitmap(Context contexto, String uri,
			int maxAncho, int maxAlto) {
		try {
			final BitmapFactory.Options options = new BitmapFactory.Options();
			options.inJustDecodeBounds = true;
			BitmapFactory.decodeStream(contexto.getContentResolver()
					.openInputStream(Uri.parse(uri)), null, options);
			options.inSampleSize = (int) Math.max(
					Math.ceil(options.outWidth / maxAncho),
					Math.ceil(options.outHeight / maxAlto));
			options.inJustDecodeBounds = false;
			return BitmapFactory.decodeStream(contexto.getContentResolver()
					.openInputStream(Uri.parse(uri)), null, options);
		} catch (FileNotFoundException e) {
			Toast.makeText(contexto, "Fichero/recurso no encontrado",
					Toast.LENGTH_LONG).show();
			e.printStackTrace();
			return null;
		}
	}

	public int uploadFile(String sourceFileUri) {

		String fileName = sourceFileUri;

		HttpURLConnection conn = null;
		DataOutputStream dos = null;
		String lineEnd = "\r\n";
		String twoHyphens = "--";
		String boundary = "*****";
		int bytesRead, bytesAvailable, bufferSize;
		byte[] buffer;
		int maxBufferSize = 1 * 1024 * 1024;
		File sourceFile = new File(sourceFileUri);

		if (!sourceFile.isFile()) {

			dialog.dismiss();

			Log.e("uploadFile", "Source File not exist :" + imagepath);

			runOnUiThread(new Runnable() {
				public void run() {

				}
			});

			return 0;

		} else {
			try {

				// open a URL connection to the Servlet
				FileInputStream fileInputStream = new FileInputStream(
						sourceFile);
				URL url = new URL(upLoadServerUri);

				// Open a HTTP connection to the URL
				conn = (HttpURLConnection) url.openConnection();
				conn.setDoInput(true); // Allow Inputs
				conn.setDoOutput(true); // Allow Outputs
				conn.setUseCaches(false); // Don't use a Cached Copy
				conn.setRequestMethod("POST");
				conn.setRequestProperty("Connection", "Keep-Alive");
				conn.setRequestProperty("ENCTYPE", "multipart/form-data");
				conn.setRequestProperty("Content-Type",
						"multipart/form-data;boundary=" + boundary);
				conn.setRequestProperty("uploaded_file", fileName);

				dos = new DataOutputStream(conn.getOutputStream());

				dos.writeBytes(twoHyphens + boundary + lineEnd);
				dos.writeBytes("Content-Disposition: form-data; name=\"uploaded_file\";filename=\""
						+ fileName + "\"" + lineEnd);

				dos.writeBytes(lineEnd);

				// create a buffer of maximum size
				bytesAvailable = fileInputStream.available();

				bufferSize = Math.min(bytesAvailable, maxBufferSize);
				buffer = new byte[bufferSize];

				// read file and write it into form...
				bytesRead = fileInputStream.read(buffer, 0, bufferSize);

				while (bytesRead > 0) {

					dos.write(buffer, 0, bufferSize);
					bytesAvailable = fileInputStream.available();
					bufferSize = Math.min(bytesAvailable, maxBufferSize);
					bytesRead = fileInputStream.read(buffer, 0, bufferSize);

				}

				// send multipart form data necesssary after file data...
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);

				// Responses from the server (code and message)
				serverResponseCode = conn.getResponseCode();
				String serverResponseMessage = conn.getResponseMessage();

				Log.i("uploadFile", "HTTP Response is : "
						+ serverResponseMessage + ": " + serverResponseCode);

				if (serverResponseCode == 200) {

					runOnUiThread(new Runnable() {
						public void run() {
							String msg = "File Upload Completed.\n\n See uploaded file here : \n\n"
									+ " F:/wamp/wamp/www/uploads";

							Toast.makeText(IntroducirReceta.this,
									"File Upload Complete.", Toast.LENGTH_SHORT)
									.show();
						}
					});
				}

				// close the streams //
				fileInputStream.close();
				dos.flush();
				dos.close();

			} catch (MalformedURLException ex) {
				ex.printStackTrace();

				runOnUiThread(new Runnable() {
					public void run() {

						Toast.makeText(IntroducirReceta.this,
								"MalformedURLException", Toast.LENGTH_SHORT)
								.show();
					}
				});

				Log.e("Upload file to server", "error: " + ex.getMessage(), ex);
			} catch (Exception e) {
				e.printStackTrace();

				runOnUiThread(new Runnable() {
					public void run() {

						Toast.makeText(IntroducirReceta.this,
								"Got Exception : see logcat ",
								Toast.LENGTH_SHORT).show();
					}
				});
				Log.e("Upload file to server Exception",
						"Exception : " + e.getMessage(), e);
			}
			return serverResponseCode;

		} // End else block
	}

}
