package com.pastamadre.mypm;

import java.util.Date;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.EditText;

public class MainActivity extends Activity {

	private Context context;
	private static EditText nombre;
	private static EditText password;
	private static EditText ciudad;
	String valorNombre;
	String valorPassword;
	private static Long milisegundos;
	private static Long milisegundosUltimoRefrescado;
	Date date = new Date();
	int puntos;
	public static AlmacenPuntuaciones almacen = new AlmacenPuntuacionesHosting();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()
				.permitNetwork().build());
		SharedPreferences pref = this.getSharedPreferences(
				"com.pastamadre.mypm_preferences", Context.MODE_PRIVATE);

		valorNombre = pref.getString("name", "");

		if (valorNombre != "") {
			lanzarElegirActividad();
		} else {
			puntos = 0;
			setContentView(R.layout.inicio_sesion);
			View animacionImagenInicio = (View) findViewById(R.id.imagenIntro);
			Animation animImag = AnimationUtils.loadAnimation(this,
					R.anim.desplazamiento_rotacion);
			animacionImagenInicio.startAnimation(animImag);

			nombre = (EditText) findViewById(R.id.nombre);
			password = (EditText) findViewById(R.id.password);
			ciudad = (EditText) findViewById(R.id.ciudad);
			Button registrar = (Button) findViewById(R.id.registrar);
			registrar.setOnClickListener(new OnClickListener() {

				public void onClick(View view) {

					lanzarElegirActividadInicial();
				}

			});

			Button cancelar = (Button) findViewById(R.id.cancelar);
			cancelar.setOnClickListener(new OnClickListener() {

				public void onClick(View view) {
					finish();
				}

			});
		}
	}

	@Override
	public void onStart() {
		super.onStart();

	}

	@Override
	public void onResume() {
		super.onResume();

	}

	@Override
	public void onPause() {
		super.onPause();

	}

	@Override
	public void onStop() {
		super.onStop();

	}

	@Override
	public void onDestroy() {
		super.onDestroy();

	}

	public void lanzarElegirActividadInicial() {
		puntos = 0;
		milisegundos = date.getTime();
		milisegundosUltimoRefrescado = date.getTime();
		SharedPreferences pref = this.getSharedPreferences(
				"com.pastamadre.mypm_preferences", Context.MODE_PRIVATE);
		SharedPreferences.Editor editor = pref.edit();
		editor.putString("name", nombre.getText().toString());
		editor.putString("password", password.getText().toString());
		editor.putString("ciudad", ciudad.getText().toString());
		editor.putString("puntos", String.valueOf(puntos));
		editor.putString("ms", milisegundos.toString());
		editor.putString("msur", milisegundosUltimoRefrescado.toString());
		editor.commit();
		almacen.guardarPuntuacion(ciudad.getText().toString(), nombre.getText()
				.toString(), puntos, password.getText().toString(),
				milisegundos);
		Intent i = new Intent(this, ElegirActividad2.class);
		startActivity(i);
	}

	public void lanzarElegirActividad() {

		Intent i = new Intent(this, ElegirActividad2.class);
		startActivity(i);
	}

	public void lanzarPreferencias(View view) {
		Intent i = new Intent(this, Preferencias.class);
		startActivity(i);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.menu, menu);
		return true;
		/** true -> el men ya est visible */
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.config:
			lanzarPreferencias(null);
			break;
		}
		return true;
		/** true -> consumimos el item, no se propaga */
	}

}
