package com.pastamadre.mypm;

import android.app.Activity;
import android.content.Intent;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.Button;

public class MeterReceta extends Activity {

	int idboton;
	SoundPool soundPool;
	int puntos;
	int imagen;
	String nombre;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		soundPool = new SoundPool(5, AudioManager.STREAM_MUSIC, 0);
		idboton = soundPool.load(this, R.raw.sonidobotones, 0);
		setContentView(R.layout.elegir_meter_recetas);

		Bundle extras = getIntent().getExtras();
		nombre = extras.getString("nombre");
		puntos = extras.getInt("puntos");

		Button pan = (Button) findViewById(R.id.boton_meter_pan);
		Animation animacionbotones = AnimationUtils.loadAnimation(this,
				R.anim.rot_botones);
		pan.startAnimation(animacionbotones);

		pan.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarMeterPan(null);
			}

		});

		Button dulces = (Button) findViewById(R.id.boton_meter_dulces);
		dulces.startAnimation(animacionbotones);

		dulces.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarMeterDulces(null);
			}

		});

		Button focaccia = (Button) findViewById(R.id.boton_meter_focaccia);
		focaccia.startAnimation(animacionbotones);

		focaccia.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarMeterFocaccia(null);
			}

		});

		Button pizza = (Button) findViewById(R.id.boton_meter_pizza);
		pizza.startAnimation(animacionbotones);

		pizza.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarMeterPizza(null);
			}

		});

		Button altro = (Button) findViewById(R.id.boton_meter_altro);
		altro.startAnimation(animacionbotones);

		altro.setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				lanzarMeterAltro(null);
			}

		});

	}

	public void lanzarMeterDulces(View view) {
		puntos = puntos + 10;
		soundPool.play(idboton, 1, 1, 1, 0, 1);
		Intent i = new Intent(this, IntroducirReceta.class);
		i.putExtra("tipo", "Dolci");
		i.putExtra("nombre", nombre);
		i.putExtra("puntos", puntos);
		startActivity(i);
	}

	public void lanzarMeterPan(View view) {
		puntos = puntos + 10;
		soundPool.play(idboton, 1, 1, 1, 0, 1);
		Intent i = new Intent(this, IntroducirReceta.class);
		i.putExtra("tipo", "Pane");
		i.putExtra("nombre", nombre);
		i.putExtra("puntos", puntos);
		startActivity(i);
	}

	public void lanzarMeterFocaccia(View view) {
		puntos = puntos + 10;
		soundPool.play(idboton, 1, 1, 1, 0, 1);
		Intent i = new Intent(this, IntroducirReceta.class);
		i.putExtra("tipo", "Focaccia");
		i.putExtra("nombre", nombre);
		i.putExtra("puntos", puntos);
		startActivity(i);
	}

	public void lanzarMeterPizza(View view) {
		puntos = puntos + 10;
		soundPool.play(idboton, 1, 1, 1, 0, 1);
		Intent i = new Intent(this, IntroducirReceta.class);
		i.putExtra("tipo", "Pizza");
		i.putExtra("nombre", nombre);
		i.putExtra("puntos", puntos);
		startActivity(i);
	}

	public void lanzarMeterAltro(View view) {
		puntos = puntos + 10;
		soundPool.play(idboton, 1, 1, 1, 0, 1);
		Intent i = new Intent(this, IntroducirReceta.class);
		i.putExtra("tipo", "Altro");
		i.putExtra("nombre", nombre);
		i.putExtra("puntos", puntos);
		startActivity(i);
	}
}
