package com.pastamadre.mypm;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class MiAdaptadorRecetas extends BaseAdapter {
	private final Activity actividad;
	private final Vector<String> lista;
	String listaString;
	String clave;

	public MiAdaptadorRecetas(Activity actividad, Vector<String> lista) {
		super();
		this.actividad = actividad;
		this.lista = lista;

	}

	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = actividad.getLayoutInflater();
		View view = inflater.inflate(R.layout.elemento_lista_recetas, null,
				true);
		TextView textView = (TextView) view.findViewById(R.id.titulo);
		textView.setText(lista.elementAt(position));
		ImageView imageView = (ImageView) view.findViewById(R.id.thumb_receta);
		try {
			Bitmap bitmap = BitmapFactory
					.decodeStream((InputStream) new URL(
							"http://www.dog-h.com/MyPM/imagenes/thumbs/2014-11-04_thumb.jpg")
							.getContent());
			imageView.setImageBitmap(bitmap);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return view;
	}

	public int getCount() {
		return lista.size();
	}

	public Object getItem(int arg0) {
		return lista.elementAt(arg0);

	}

	public long getItemId(int position) {
		return position;
	}

}
